$!
$!	PROCEDURE TREESIZE
$!
$!		This procesure computes the number of blocks in the directory 
$!	structrues passed as parameter.  The structure is assumed to be 
$!	a VAX SIG Symposium tape directory on SYS$DISK:.
$!
$!		To save time we do not always need to count the blocks; 
$!	this procedure saves the count in a file, and if the same 
$!	structure is called for again in a subsequent call, it simply
$!	reads the count from the file.  This is not done for [VAX000]
$!	and its components, since its size can change.  For example, the
$!	size of [VAX82B...] is saven id the file 'VAX82B.SIZ'.
$!
$!	The output of this procedure is the symbol BLOCKS.
$!
$	ON CONTROL_Y THEN $GOTO CLEANUP
$	ON ERROR THEN $GOTO CLEANUP
$!
$	WRITE SYS$OUTPUT "
Computing the number of blocks in ''P1'"
$!
$	NAME = ""
$!
$	IF F$LOCATE("[VAX000", P1) .EQS. 0 THEN $GOTO COUNT
$!
$	NAME = F$EXTRACT (1,6,P1) + ".SIZ"
$	IF F$SEARCH(NAME) .EQS. "" THEN $GOTO COUNT
$!
$	OPEN TTEMP 'NAME'
$	READ TTEMP BLOCKS
$	CLOSE TTEMP
$!
$	BLOCKS == BLOCKS
$	GOTO EXIT
$!
$COUNT:
$	IF NAME .NES. "" THEN -
		WRITE SYS$OUTPUT "
        This is going to take a while..."
$!
$	DIR/SIZE/TOTAL/OUTPUT=TTEMP.TMP SYS$DISK:'P1'
$!
$	OPEN TTEMP TTEMP.TMP
$!
$LOOP:
$	READ/END=END TTEMP LINE
$	GOTO LOOP
$!
$END:
$	CLOSE TTEMP
$	DELETE TTEMP.TMP;*
$!
$	COL = F$LOCATE("files,",LINE)+7
$	LEN = F$LOCATE(" blocks",line)-COL
$	BLOCKS == F$EXTRACT(COL,LEN,LINE)
$!
$	IF NAME .EQS. "" THEN $GOTO EXIT
$!
$	OPEN/WRITE TTEMP 'NAME'
$	WRITE TTEMP BLOCKS
$	CLOSE TTEMP
$!
$EXIT:
$	WRITE SYS$OUTPUT "
''P1' Contains ''BLOCKS' Blocks.
"
$	EXIT
$!
$CLEANUP:
$	SET NOON
$	IF F$LOGICAL("TTEMP") .NES. "" THEN CLOSE TTEMP
$	IF F$SEARCH("TTEMP.TMP") .NES. "" THEN DELETE TTEMP.TMP;*
$!
